// ==============================================================
//                 ORBITER MODULE: CustomMFD
//                  Part of the ORBITER SDK
//           Copyright (C) 2002-2003 Martin Schweiger
//                   All rights reserved
//
// CustomMFD.cpp
// Reference implementation of generic user-defined MFD mode
// ==============================================================

#define STRICT
#define ORBITER_MODULE
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "orbitersdk.h"
#include <string>
using namespace std;
// ==============================================================
void CollisionFunction();




// Global variables
int dirx;
int diry;
int dirz;
int ObjectCount;

char CLOSEST [25];
int a;
double c;
double hvsize;
VECTOR3 Temp;
OBJHANDLE Myvessel;
OBJHANDLE hvessel2;

VECTOR3 RelPos; // position relative to object
VECTOR3 AppDir; // approach direction
VECTOR3 MyVector3;
VECTOR3 OtherVector3;


static struct {  // "Ascent MFD" parameters
	int mode;      // identifier for new MFD mode
	
} g_collisionMFD;



// ==============================================================
// API interface


class CollisionMFD: public ExternMFD {

	

public:
	

  
    
     
	

private:
   
	


	
};


//////////////////////////////////////////////////////////////////////

DLLCLBK void opcDLLInit (HINSTANCE hDLL)
{

	ObjectCount = 0;
    a = 0;
	c = 0;
 


}

DLLCLBK void opcDLLExit (HINSTANCE hDLL)
{


}


DLLCLBK void opcPreStep (double simt, double simdt, double mjd)
{

VESSEL *v = oapiGetFocusInterface(); // get vessel with focus my vessel
		

 
MyVector3 = _V(8,2.5,9.5);	// distance to trigger action
OtherVector3 = _V(10,10,10);  // vector3 for other vessel 


//////////////////////////////////////////////////



Myvessel=oapiGetVesselByName(v->GetName());
ObjectCount = oapiGetVesselCount();// determine number of vessels

hvessel2 = oapiGetVesselByIndex(a);//(a); // 3 = dgs


hvsize = oapiGetSize(hvessel2);


VESSEL *v2 = oapiGetVesselInterface (hvessel2);// other ship

 char NAME[3];
char MYNAME[3] ;

oapiGetObjectName(hvessel2,NAME,3);//

oapiGetObjectName(v->GetHandle(),MYNAME,3);
       

		if (oapiIsVessel(hvessel2) == true){      // check that vessel still exist
          
			v->GetRelativePos (hvessel2, RelPos );

		}
        /////// get approach direction
		if (RelPos.x < 0){dirx = -1;}
		if (RelPos.x > 0){dirx = 1;}
        if (RelPos.y < 0){diry = -1;}
		if (RelPos.y > 0){diry = 1;}
        if (RelPos.z < 0){dirz = -1;}
		if (RelPos.z > 0){dirz = 1;}

             AppDir.x = dirx;
             AppDir.y = diry;
             AppDir.z = dirz;
        // change numbers to positive
          if (RelPos.x < 0){
    	RelPos.x = -(RelPos.x) ;}
          if (RelPos.y < 0){
        RelPos.y = -(RelPos.y) ;}
          if (RelPos.z < 0){ 
        RelPos.z = -(RelPos.z) ;}

 //// define min dist for all vehicles
/////////////////////////////////////////////////
////////////////////////////////////////////////
char shuttlea[] = "SH-";
char deltag[] = "GL-";
char pb[] = "PB-";
char iss[] = "ISS";
//// set vessel sizes
if(!strcmp(shuttlea,NAME )) {

     OtherVector3 = _V(3,10,17.5); // width,height,length // from center
   
}


if(!strcmp(deltag,NAME )) {
OtherVector3 = _V(8,2.5,9.5); //deltaglider


}
if(!strcmp(pb,NAME )) {

OtherVector3 = _V(0.4,1.2,3);


}

if(!strcmp(iss,NAME )) {

OtherVector3 = _V(11,15,6);


}
///////////////////////Add OtherVector3///////////////////////////////
    
	
   MyVector3.x = (MyVector3.x + OtherVector3.x);
	MyVector3.y = (MyVector3.y + OtherVector3.y);
	 MyVector3.z = (MyVector3.z + OtherVector3.z);
     

  // othervector3 = other vessel vector3 size
     if (MyVector3.x  > RelPos.x  &&  MyVector3.y  > RelPos.y  && MyVector3.z  > RelPos.z ){//    
	    
		 // Add IF collision code here
		 if(hvessel2 == v->GetHandle()){
		 }
		 else{

            CollisionFunction();


		 }
	
	 }

a=a+1; // check next vessel
 if(a == ObjectCount  ){
			a = 0;
            
		}
}









void CollisionFunction()
{
	
	VESSEL *v = oapiGetFocusInterface(); // get vessel with focus my vessel
    VESSEL *v2 = oapiGetVesselInterface (hvessel2);// other ship

			 ////Current focus vessel
VECTOR3 vec3 ;
v->GetShipAirspeedVector(vec3);


	
VECTOR3 vec32 ;
v2->GetShipAirspeedVector(vec32);

/// my vessel
 VESSELSTATUS2 vs;
	memset (&vs, 0, sizeof (vs));
	vs.version = 2;
	v->GetStatusEx (&vs);
//	vs.flag = VS_FUELRESET | VS_THRUSTRESET;
	VECTOR3 ofs = _V(0, 0, -1);
	
	
//other vessel///////////////////////////////////////////////////////////////
 VESSELSTATUS2 vs2;                   ////   the other ship settings
	memset (&vs2, 0, sizeof (vs2));
	vs2.version = 2;
	v2->GetStatusEx (&vs2);
//	vs.flag = VS_FUELRESET | VS_THRUSTRESET;
	VECTOR3 ofs2 = _V(0, 0, 0);
	VECTOR3 rofs2, rvel2 = {vs.rvel.x, vs.rvel.y, vs.rvel.z};
	VECTOR3 vel2 = {0,0,0 };
/// my vessel
    
	VECTOR3 rofs, rvel = {vs2.rvel.x , vs2.rvel.y  , vs2.rvel.z };
	VECTOR3 vel = {0,0,-2}; // speed
  
	
	v->Local2Rel (ofs, vs.rpos);
	v->GlobalRot (vel, rofs);
	vs.rvel.x = rvel.x+rofs.x;
	vs.rvel.y = rvel.y+rofs.y;
	vs.rvel.z = rvel.z+rofs.z;
	vs.vrot.y = 0;
	vs.status = 0;
//other vessel

    v2->Local2Rel (ofs2, vs2.rpos);
	v2->GlobalRot (vel2, rofs2);
	vs2.rvel.x = rvel2.x+rofs2.x;
	vs2.rvel.y = rvel2.y+rofs2.y;
	vs2.rvel.z = rvel2.z+rofs2.z;
	if( v->GroundContact() == true){
	vs2.vrot.x =AppDir.x / 3;
	vs2.vrot.y =AppDir.y / 3;
	vs2.vrot.z =AppDir.x / 3;}
	vs2.status = 0;



          v2->DefSetStateEx(&vs2);    // other ship
           v->DefSetStateEx(&vs);


a = 0;
	
}


